#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "../libweb/webutil.h"
#include "food.h"

/*----------------------------------------------------------------------------*/

static void Missing( char* field )
{
   printf( "You didn't fill in field '%s'.<br>%c", field, 10 );
}

/*----------------------------------------------------------------------------*/

int main( int argc, char* argv[] )
{
   entry entries[MAX_ENTRIES];
   FILE* fp;
   int m, i, missing;
   int recv[14], reqd[14];
   char *field[14], *val[14], buf[1024];

   for( i = 1; i < 14; i++ )
   {
       recv[i]=0;
       reqd[i]=0;
       field[i]="";
       val[i]=0;
   }

   reqd[1] = 1; field[1] = "Restaurant";
   reqd[2] = 1; field[2] = "Street";
   reqd[7] = 1; field[7] = "Telephone";
   reqd[8] = 1; field[8] = "Type";

   /* for( i = 1; i < argc; i++ ) reqd[atoi(argv[i])] = 1; */

   printf( "Content-type: text/html%c%c", 10, 10 );
   m = CGIInit( entries );
   if( m < 0 ) return 1;

   printf(
   "<TITLE>Toronto's WWW Restaurant Listings -- Add restaurant</TITLE>%c",
   10 );

   for( i = 0; i <= m; i++ )
   {
      int j = atoi(entries[i].name);
      if( entries[i].val != 0 && strcmp( entries[i].val, "" ) != 0 )
      {
         recv[j] = 1;
         if( val[j] != 0 )
            sprintf( buf, "%s,%s", val[j], entries[i].val );
         else
            sprintf( buf, "%s", entries[i].val );
         val[j] = strdup( buf );
      }
   }

   for( i = 1; i < 14; i++ )
      if( reqd[i] && ! recv[i] )
      {
         missing = 1;
         Missing( field[i] );
      }

   if( ! missing )
   {
      buf[0] = 0;
      for( i = 1; i < 14; i++ )
      {
         if( i > 1 ) sprintf( buf+strlen(buf), "|" );
         if( recv[i] ) sprintf( buf+strlen(buf), "%s", val[i] );
      }

      /*fp = popen( "mail -s 'Add restaurant' noik@db.toronto.edu", "w" );*/
      fp = fopen( "/u/noik/web/symsol.com/lib/restaura/updates.txt", "a" );
      fprintf( fp, "%s\n", buf );
      fclose( fp );

      printf( "<P>Thank you for helping us to expand our database! " );
      printf(
      "We'll verify your submission and add it to the list shortly.<BR>" );
   }
   else
   {
      printf( "<p>Please go back to the previous page and try again.<BR>%c",
      10 );
   }

   return 0;
}

/*----------------------------------------------------------------------------*/
