#
#  bizdir.awk  Ver 1.0
#
#  <C> Copyright 1995 Symbiotic Solutions
#  Authors:  Emanuel Noik
#
#  This code may look like awk but it's actually gawk!
#
#-------------------------------------------------------------------------------

BEGIN {
   FS="|";		# field separator
   n = 0;		# number of hits

   print "<html><header>";
   print "<title>All Canada Business Registry - Search Results</title>";
   print "</header>";
   #print "<body bgcolor=\"ffffe8\">";
   #print "<body>";
   print "<body background=\"/db/bizdir/acbrbg.gif\">";
   print "<center><img src=\"/db/bizdir/acbr2.gif\">";
   print "<h2>Search Results</h2><hr></center>";

   dbInit();		# initialize database package
   dbMaxHits=5;		# set default maximum hits (temporary)

   dbField(1, "S", "" )		# name
   dbField(2, "S", "" )		# street
   dbField(3, "S", "" )		# city
   dbField(4, "S", "" )		# postal
   dbField(5, "S", "" )		# tel
   dbField(6, "M", "" )		# SIC codes

   dbArgs();		# process form contents
}

#-------------------------------------------------------------------------------

{
   if( NR < dbOffset ) next;	# skip records

   if( myFilter() )		# is current record a Hit?
   {
      if( n == dbMaxHits )	# only show dbMaxHits
      {
         dbMoreHits( sprintf( "/cgi-bin/bizdir?%s", file ) );
         exit;
      }

      print "<P><B>" $1 "</B>, "
      if( $2 != "" ) print $2 ", "
      print "<I>" $3 ", " qv[4,1] "</I>, "
      # if( $4 != "" ) print "<I>" substr($4,1,3) " " substr($4,4) "</I>, "
      print "(" substr($5,1,3) ") " substr($5,4,3) "-" substr($5,7) " "
      # print "{" $6 "}<BR>"
      print "<BR>"
      n++;
   }
}

#-------------------------------------------------------------------------------

function myFilter() {
   return dbFilterI(1) > -1 && dbFilterI(2) > -1 && dbFilterI(3) > -1 ? 1 : 0;
}

#-------------------------------------------------------------------------------

END {
   if( dbErr )
   {
      print "Received bad data from form, your browser sucks!";
   }
   else
   {
      print "<hr>";
      dbFooter();
   }
   print "</body></html>";
}

#-------------------------------------------------------------------------------
