static char* authorBits[] = {
 "Mike Grenby",
 "Jim Kershaw",
 0
};
static char* subjectBits[] = {
 "annuity",
 "bond",
 "budget",
 "capital gain",
 "currency",
 "CMHC",
 "credit card",
 "CSB",
 "disability insurance",
 "dividend",
 "exchange",
 "financial planning",
 "GIC",
 "GST",
 "income tax",
 "inheritance",
 "leverage",
 "life insurance",
 "mortgage",
 "mutual fund",
 "PST",
 "real estate",
 "retirement",
 "Revenue Canada",
 "RRIF",
 "RRSP",
 "securities",
 "self-employment",
 "stock",
 "tenant",
 0
};
static char* affilBits[] = {
 "The Art of Investment",
 0
};
static DBMask masks[] = {
 { "author", authorBits },
 { "subject", subjectBits },
 { "affil", affilBits },
 { "", 0 }
};
static DBField fields[] = {
 { LOOKUP, "author" },
 { DATE, "date" },
 { STRING, "title" },
 { MASK, "subject" },
 { STRING, "url" },
 { LOOKUP, "affil" },
 { LAST, 0 }
};
static char f_author[16];
static char f_date[16];
static char f_title[255];
static char f_subject[16];
static char f_url[255];
static char f_affil[16];
void LoadVariables( void ) {
   dbValue( 0, f_author );
   dbValue( 1, f_date );
   dbValue( 2, f_title );
   dbValue( 3, f_subject );
   dbValue( 4, f_url );
   dbValue( 5, f_affil );
}
